//
//		IGETF
//
//		HTTP file transfer application
//
//
//		Version history:
//		
//		1.000.1		Feb 24 2003		Released into public domain
//		1.000.2		May 02 2003		Implemented silent switch and target name
//
//

#include "stdafx.h"
#include <wininet.h>

static const char *kszAgent = "Esaro Intergalactic/1.0";

// types
typedef enum
{
	CMD_GET_FILE,
	CMD_SHOW_HELP
}COMMAND;

typedef struct _PROGRAM_DATA
{
	COMMAND cmd;
	bool silent;
	char* filename;
	unsigned exit_code;
	char output_file[256];

	// transferred file data
	HINTERNET hOpen;
	FILE* fp;
	DWORD dwSize;
	HINTERNET hInet;
	long lReadSize;
}PROGRAM_DATA;


//prototypes
int show_usage();
int get_file(PROGRAM_DATA* pd);
int get_file_component(char* path, char* file);



int get_file(PROGRAM_DATA* pd)
{
	HINTERNET  hConnect;
	CHAR   szHead[] = "Accept: */*\r\n\r\n";
	CHAR pszOut[1024];
	DWORD dwSizeRead;
	DWORD dwBytesRead;
	DWORD dwState;
	unsigned lTotalRead = 0;

	// Test if we need to dial up
	if(InternetGetConnectedState(&dwState, 0) == FALSE){
		pd->hInet = NULL;
	}

	if(!pd->silent)
		printf("Opening %s\n", pd->filename);

	// Create connection on our side
	pd->hInet = InternetOpen(
		kszAgent, INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
	// Connect to remote side
	if ( !(hConnect = InternetOpenUrl ( pd->hInet, pd->filename, szHead,
		lstrlen (szHead), INTERNET_FLAG_DONT_CACHE, 0)))
	{
		// "Error !" << endl;
		return 0;
	}

	// Transfer loop
	if(!pd->silent)
		printf("Transferring to local %s\n", pd->output_file);
	do{
		dwSizeRead = 1024;
		if (!InternetReadFile(hConnect, pszOut, dwSizeRead,  &dwBytesRead) )
		{
			printf("Fatal: read error\n");
            return 0;
		}
		lTotalRead += dwBytesRead;
		if (!dwBytesRead)
			break;  // Condition of dwSize=0 indicate EOF. Stop.
		else{
			fwrite(pszOut, dwBytesRead, 1, pd->fp);
			}
	}   // do
	while (TRUE);
	if(!pd->silent)
		printf("Transferred %d bytes\n", lTotalRead);
	return lTotalRead;
}


// implementation
int exec_cmd(PROGRAM_DATA* pd)
{
	int rslt;
	if(pd->cmd == CMD_SHOW_HELP)
		return show_usage();
	if(pd->cmd == CMD_GET_FILE){
		if(pd->output_file[0] == 0)
			get_file_component(pd->filename, pd->output_file);
		pd->fp = fopen(pd->output_file, "wb");
		rslt = get_file(pd);
		fclose(pd->fp);
		return rslt;
	}
	return -1;
}


int show_usage()
{
	printf("iGetf by Fuck Station Zero Software\n");
	printf("version 1.000.2 (" __DATE__ ")\n");
	printf("Usage:\n\n");
	printf("igetf URL [-v] [-s] [-xN] [target file]\n\n");
	printf("where \"URL\" is the full adress of file to get\n\n");
	printf("Switches:\n");
	printf("-n\tno questions asked\n");
	printf("-s\tsilent mode (implies -n)\n");
	printf("-xN\tN is exit code of process\n");
	printf("-?\tthis screen\n");
	return 0;
}



int get_file_component(char* path, char* file)
{
	char* cp;

	cp = strrchr(path, '/');
	if(cp){
		cp ++;
		strcpy(file, cp);
		return strlen(file);
	}
	return 0;
}


int main(int argc, char* argv[])
{
	char* cp;
	int i;
	PROGRAM_DATA pd;
	int rslt;

	pd.cmd = CMD_SHOW_HELP;
	pd.filename = NULL;
	pd.output_file[0] = 0;
	rslt = 0;

	/* find out what the user wants us to do */
	for(i = 1; i < argc; i++){
		cp = argv[i];
		while(*cp){
			switch(*cp){
			/* read the switches */
			case '/':
			case '-':
				cp++;
				switch(*cp){
				case 's':
					pd.silent = true;
					break;
				case 'x':
					cp++;
					pd.exit_code = strtoul(cp, &cp, 10);
					cp--;
					break;
				default:
					printf("Unknown switch: %s\n", argv[i]);
					show_usage();
					return -1;
				case '?':
					return show_usage();
					break;
				}
				break;
			/* otherwise, we assume its a filename */
			default:
				if(pd.filename == NULL){
					pd.filename = cp;
					pd.cmd = CMD_GET_FILE;
				}
				else{
					strcpy(pd.output_file, cp);
				}
				cp += strlen(cp) - 1;
				break;
			};
			cp++;
		};
	}

	/* do it */
	rslt = exec_cmd(&pd);
	return rslt;
}

